searchNodes=[{"doc":"This guide provide the necessary to configure and use the Wavexfront and start monitoring your applicationConfigurationThe :wavexfront application needs to be configured properly in order to work. This configuration can be done, for example, in config/config.exs:config :wavexfront, enabled: true, histogram_1m: [ enabled: true, host: &quot;myhost.com&quot; ]This would enabled wavexfront and start a connection pool for the 1 minute histogram support. This will also send the metrics to &quot;myhost.com&quot; on default port 40001:enabled - Enable sending metrics to Wavefront proxy. If set to false it is not even attempting to send them. If value is set to :log, metrics will be showing in the logs. If set to true, metrics will attempt to forward to the the correct connection pool and proxy configured based on the type of metric sent. Default values is false.One or many configuration for each pool.This library is quite configurable so you can decide where to send the metrics and how much concurrency you want for it (using pool connection)There are currently 4 connection pools supported:histogram_1m: for Minute histograms metricshistogram_1h: for Hourly histograms metricshistogram_1d: for daily histograms metricscounter_and_gauge: for counter and gauge metricsEach connection pool has its own set of configuration. The following options are available:enabled - Wether to enable this connection pool or not. When false, the connection pool will not be started:host - The host to send the metrics too. Default to localhost:port - The port to connect to. Defaults are:for histogram_1m: 40001for histogram_1h: 40002for histogram_1d: 40003for counter_and_gauge: 2878:timeout - Connection timeout:pool_size - Number of connection in the poolSending metricsIn order to send metrics, a simple API exists. Currently we do not support storing locally metrics and then then send the data to the proxy. We expect the proxy to store histogram or counter value and take care of it. Which means need to talk to the same proxy.For counter, you will need to store yourself the counter (in process, state or :ets table) if you decide to use themHere is how you would send an histogram valueWavexfront.send_histogram(&quot;my_histo&quot;, value: 2, source: &quot;my_host&quot;, labels: [name: :value])","ref":"Wavexfront.html","title":"Wavexfront","type":"module"},{"doc":"","ref":"Wavexfront.html#client_config/0","title":"Wavexfront.client_config/0","type":"function"},{"doc":"","ref":"Wavexfront.html#connection_pool_spec/1","title":"Wavexfront.connection_pool_spec/1","type":"function"},{"doc":"","ref":"Wavexfront.html#counter_and_gauge_enabled?/0","title":"Wavexfront.counter_and_gauge_enabled?/0","type":"function"},{"doc":"","ref":"Wavexfront.html#default_config_parse/1","title":"Wavexfront.default_config_parse/1","type":"function"},{"doc":"","ref":"Wavexfront.html#default_port/1","title":"Wavexfront.default_port/1","type":"function"},{"doc":"","ref":"Wavexfront.html#histogram_enabled?/1","title":"Wavexfront.histogram_enabled?/1","type":"function"},{"doc":"","ref":"Wavexfront.html#histogram_type_for/1","title":"Wavexfront.histogram_type_for/1","type":"function"},{"doc":"","ref":"Wavexfront.html#pool_size_config/1","title":"Wavexfront.pool_size_config/1","type":"function"},{"doc":"","ref":"Wavexfront.html#send_counter/3","title":"Wavexfront.send_counter/3","type":"function"},{"doc":"","ref":"Wavexfront.html#send_delta_counter/3","title":"Wavexfront.send_delta_counter/3","type":"function"},{"doc":"","ref":"Wavexfront.html#send_gauge/3","title":"Wavexfront.send_gauge/3","type":"function"},{"doc":"","ref":"Wavexfront.html#send_histogram/3","title":"Wavexfront.send_histogram/3","type":"function"},{"doc":"","ref":"Wavexfront.html#send_metric/3","title":"Wavexfront.send_metric/3","type":"function"},{"doc":"Callback implementation for Application.start/2.","ref":"Wavexfront.html#start/2","title":"Wavexfront.start/2","type":"function"},{"doc":"","ref":"Wavexfront.html#wavexfront_enabled?/0","title":"Wavexfront.wavexfront_enabled?/0","type":"function"},{"doc":"","ref":"Wavexfront.html#worker_config/1","title":"Wavexfront.worker_config/1","type":"function"},{"doc":"This is the representation of metric item as a structurename: The name of your metrictype: The type of metric. Must be one of :histogram_1m, histogram_1h, histogram_1d, :counter or :gaugetimestamp: The timestamp of the metrics. May be nil and will be then resolved by the proxysource: The host it was sent fromlabels: Keyword list of extra labelsdelta: Only applies to counters if they are delta countersThe serialization of the metrics is done by using the Item.to_text function.","ref":"Wavexfront.Item.html","title":"Wavexfront.Item","type":"module"},{"doc":"","ref":"Wavexfront.Item.html#new/1","title":"Wavexfront.Item.new/1","type":"function"},{"doc":"","ref":"Wavexfront.Item.html#to_text/1","title":"Wavexfront.Item.to_text/1","type":"function"},{"doc":"This is the actual connection to the proxy and handle all the TCP aspect of sending the message to the proxy","ref":"Wavexfront.Proxy.Worker.html","title":"Wavexfront.Proxy.Worker","type":"module"},{"doc":"","ref":"Wavexfront.Proxy.Worker.html#close/1","title":"Wavexfront.Proxy.Worker.close/1","type":"function"},{"doc":"","ref":"Wavexfront.Proxy.Worker.html#recv/3","title":"Wavexfront.Proxy.Worker.recv/3","type":"function"},{"doc":"","ref":"Wavexfront.Proxy.Worker.html#send/2","title":"Wavexfront.Proxy.Worker.send/2","type":"function"},{"doc":"","ref":"Wavexfront.Proxy.Worker.html#start_link/1","title":"Wavexfront.Proxy.Worker.start_link/1","type":"function"},{"doc":"WavexfrontElixir client for WavefrontSpecification of the format can be found here","ref":"readme.html","title":"Wavexfront","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding wavexfront to your list of dependencies in mix.exs:def deps do [ {:wavexfront, &quot;~&gt; 0.1.0&quot;} ] endThen run mix deps.get in your shell to fetch the dependencies.Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/wavexfront.You can also generate the documentation locally withmix docsThen open the doc/index.html generated","ref":"readme.html#installation","title":"Wavexfront - Installation","type":"extras"},{"doc":"Wavefront requires some configuration in order to work. For example, in config/config.exs:config :wavexfront, enabled: true, histogram_1m: [enabled: true], counter_and_gauge: [enabled: true] For detailed information on configuration and usage, take a look at the online documentation.Now in order to send a metric you can use the following APIHistogram Wavexfront.send_histogram(&quot;my_histogram&quot;, value: 42, source: &quot;myhost&quot;, labels: [yo: &quot;mama&quot;])Counter Wavexfront.send_counter(&quot;my_counter&quot;, source: &quot;myhost&quot;, labels: [yo: &quot;mama&quot;]) # or Delta counter (if you do not maintain the counter yourself) Wavexfront.send_delta_counter(&quot;my_counter&quot;, source: &quot;myhost&quot;, labels: [yo: &quot;mama&quot;])Gauge Wavexfront.send_gauge(&quot;my_gauge&quot;, value: 2, source: &quot;myhost&quot;, labels: [yo: &quot;mama&quot;])","ref":"readme.html#usage","title":"Wavexfront - Usage","type":"extras"},{"doc":"To run tests, run:mix testAlso make sure to run the following to check that there are no warning/error reported by credo. So you will want to run:mix credoAlso make sure your code is formatted using the elixir formattermix formatFinally, thanks for contributing! :)","ref":"readme.html#contributing","title":"Wavexfront - Contributing","type":"extras"},{"doc":"This software is licensed under Apache License 2.0","ref":"readme.html#license","title":"Wavexfront - License","type":"extras"}]